#!/usr/bin/ruby

require "rbconfig"

$OS = RbConfig::CONFIG["target_os"]

if $OS =~ /mswin/i
  LIBEXT = ".lib"
  LIBS = ""
else
  LIBEXT = ".a"
  LIBS = "-L-ljpeg -L-lz -L-lpng "
  LIBFILES = "lib/ngbase.a lib/avimport.a -L-ljpeg -L-lz -L-lpng -L-lavcodec -L-lavdevice -L-lavfilter -L-lavformat -L-lavresample -L-lavutil -L-lswscale"
end

def files(dir)
  files = (Dir.entries(dir)).select(){|s| s =~ /.+\.(d|di|lib)$/}
  for i in 0...files.size
    files[i] = "#{dir}/" + files[i]
  end
  return files.join(" ")
end

option = ARGV.join(" ")

def exec(text)
  text.gsub!("\n"){" "}
  print text + "\n\n"
  `#{text}`
end

exec("dmd #{option} -of\"lib/ngbase#{LIBEXT}\" #{LIBS}-lib #{files('ngbase')}")
#=begin
exec( <<-"EOM"
dmd #{option} -c -of"lib/avimport#{LIBEXT}" -lib libav/libavcodec/avcodec.d libav/libavcodec/_version.d
libav/libavcodec/avfft.d #{files("libav/libavdevice")} #{files("libav/libavfilter")} #{files("libav/libavformat")}
#{files("libav/libavresample")} #{files("libav/libavutil")} #{files("libav/libswscale")}
EOM
)
#=end
if $OS =~ /mswin/i
  #exec("dmd #{option} movietest.d formats.d #{files('lib')}")
  exec("dmd -of\"BGAEncAdv\" -version=\"WIDE\" #{option} bgaencoder.d formats.d #{files('libpng')} #{files('libjpeg')} #{files('util')} #{files('loader')} #{files('lib')}")
else
  #exec("dmd #{option} movietest.d formats.d import/avimport.o #{libfiles}")
  exec("dmd -of\"BGAEncAdv\" -version=\"WIDE\" #{option} bgaencoder.d formats.d #{files('libpng')} #{files('libjpeg')} #{files('util')} #{files('loader')} #{LIBFILES}")
end
