module libav.libavcodec._version;
/**
 
 * This file is part of Libav.*
 
 * Libav is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.*
 
 * Libav is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.*
 
 * You should have received a copy of the GNU Lesser General Public
 * License along with Libav; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/**
 * @file
 * @ingroup libavc
 * Libavcodec version macros.
 */

import libav.libavutil.avutil;

immutable int LIBAVCODEC_VERSION_MAJOR = 55;
immutable int LIBAVCODEC_VERSION_MINOR = 10;
immutable int LIBAVCODEC_VERSION_MICRO  = 0;

immutable int LIBAVCODEC_VERSION_INT  = AV_VERSION_INT(LIBAVCODEC_VERSION_MAJOR, LIBAVCODEC_VERSION_MINOR, LIBAVCODEC_VERSION_MICRO);
string LIBAVCODEC_VERSION             = AV_VERSION(LIBAVCODEC_VERSION_MAJOR, LIBAVCODEC_VERSION_MINOR, LIBAVCODEC_VERSION_MICRO);
alias LIBAVCODEC_VERSION_INT LIBAVCODEC_BUILD;

string LIBAVCODEC_IDENT               = AV_JOIN("Lavc", AV_VERSION(LIBAVCODEC_VERSION_MAJOR, LIBAVCODEC_VERSION_MINOR, LIBAVCODEC_VERSION_MICRO));

/**
 * FF_API_* defines may be placed below to indicate public API that will be
 * dropped at a future version bump. The defines themselves are not part of
 * the public API and may change, break or disappear at any time.
 */

immutable bool FF_API_REQUEST_CHANNELS = (LIBAVCODEC_VERSION_MAJOR < 56);
immutable bool FF_API_DEINTERLACE = (LIBAVCODEC_VERSION_MAJOR < 56);
immutable bool FF_API_DESTRUCT_PACKET = (LIBAVCODEC_VERSION_MAJOR < 56);
immutable bool FF_API_GET_BUFFER = (LIBAVCODEC_VERSION_MAJOR < 56);
immutable bool FF_API_MISSING_SAMPLE = (LIBAVCODEC_VERSION_MAJOR < 56);
immutable bool FF_API_LOWRES = (LIBAVCODEC_VERSION_MAJOR < 56);
/* AVCODEC_VERSION_H */
