module libav.libavfilter._version;
/*
 * Version macros.*
 
 * This file is part of Libav.*
 
 * Libav is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.*
 
 * Libav is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.*
 
 * You should have received a copy of the GNU Lesser General Public
 * License along with Libav; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/**
 * @file
 * @ingroup lavfi
 * Libavfilter version macros
 */

import libav.libavutil.avutil;

immutable int LIBAVFILTER_VERSION_MAJOR  = 3;
immutable int LIBAVFILTER_VERSION_MINOR  = 10;
immutable int LIBAVFILTER_VERSION_MICRO  = 0;

immutable int LIBAVFILTER_VERSION_INT = AV_VERSION_INT(LIBAVFILTER_VERSION_MAJOR, LIBAVFILTER_VERSION_MINOR, LIBAVFILTER_VERSION_MICRO);
string LIBAVFILTER_VERSION            = AV_VERSION(LIBAVFILTER_VERSION_MAJOR, LIBAVFILTER_VERSION_MINOR, LIBAVFILTER_VERSION_MICRO);
alias LIBAVFILTER_VERSION_INT LIBAVFILTER_BUILD;

/**
 * FF_API_* defines may be placed below to indicate public API that will be
 * dropped at a future version bump. The defines themselves are not part of
 * the public API and may change, break or disappear at any time.
 */

immutable bool FF_API_AVFILTERPAD_PUBLIC = (LIBAVFILTER_VERSION_MAJOR < 4);
immutable bool FF_API_FOO_COUNT = (LIBAVFILTER_VERSION_MAJOR < 4);
immutable bool FF_API_AVFILTERBUFFER = (LIBAVFILTER_VERSION_MAJOR < 4);
immutable bool FF_API_OLD_FILTER_OPTS = (LIBAVFILTER_VERSION_MAJOR < 4);
immutable bool FF_API_AVFILTER_OPEN = (LIBAVFILTER_VERSION_MAJOR < 4);
immutable bool FF_API_AVFILTER_INIT_FILTER = (LIBAVFILTER_VERSION_MAJOR < 4);
immutable bool FF_API_OLD_FILTER_REGISTER = (LIBAVFILTER_VERSION_MAJOR < 4);
/* AVFILTER_VERSION_H */
