module libav.libavutil.md5;
/*
 * copyright (c) 2006 Michael Niedermayer <michaelni@gmx.at>*
 
 * This file is part of Libav.*
 
 * Libav is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.*
 
 * Libav is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.*
 
 * You should have received a copy of the GNU Lesser General Public
 * License along with Libav; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */
import libav.libavutil.attributes;
import libav.libavutil._version;

/**
 * @defgroup lavu_md5 MD5
 * @ingroup lavu_crypto
 * @{
 */

static if(FF_API_CONTEXT_SIZE){
    export int av_md5_size;
}

struct AVMD5{}

AVMD5* av_md5_alloc();
void av_md5_init(AVMD5* ctx);
void av_md5_update(AVMD5* ctx, ubyte* src, int len);
void av_md5_final(AVMD5* ctx, ubyte* dst);
void av_md5_sum(ubyte dst, ubyte* src, int len);

/**
 * @}
 */

/* AVUTIL_MD5_H */
